package require snit
package require snitwiz

namespace eval ::kwiz:: {
     variable wprops
     
     # Base window path
     variable bwinpath
     
     # Store all step snit variable step identifier
     variable stepidlist
     
     # Store all wiz step 
     variable wizstepidlist
}

proc ::kwiz::Init {} {
     # ABSTRACT: Init namespace some variables
 
     # Init the base window path inside GiD        
     variable bwinpath
     set bwinpath ".gid.wtest"
     
     variable wprops
     set wprops(dummy) 0 

     # Init step id list
     variable stepidlist [list]
     set stepidlist [list ::kwiz::stepType ::kwiz::stepDim]
     
     variable wizstepidlist [list]
     set wizstepidlist [list "SpaceDimenison" "AppType" ]
}

proc ::kwiz::InitStepVariables { } {

     set ::kwiz::wprops(SpaceDimenison,nDim) 0
     set ::kwiz::wprops(AppType,App) 0
}

proc ::kwiz::CambiodeProblemType { } {
     variable wprops
     variable bwinpath
     
     # Los DEM van a parte
     if {$wprops(AppType,App) != "DEMFluid"} {
          set auxfile [file nativename [file join [GidUtils::GetTmp] "KratosInitFile.tcl" ] ]
          set ch [open $auxfile w]
          
          puts $ch "proc script \{\} \{"
          # Dimension selection
          puts $ch "    ::xmlutils::setXml \"GeneralApplicationData//c.Domain//i.SpatialDimension\" dv \"write\" $wprops(SpaceDimenison,nDim)"
               
          # Apagamos todos los Application types
          puts $ch "    ::KMProps::DisableAllAppsandEnableOnly $wprops(AppType,App)"
          
          # Si estamos en 3D ocultamos todo el ndim
          if {($wprops(AppType,App) ne "StructuralAnalysis")} {
               puts $ch "    ::xmlutils::setXml \"GeneralApplicationData\" state \"write\" \"hidden\""
               puts $ch "    ::xmlutils::setXml \"GeneralApplicationData//c.Domain\" state \"write\" \"hidden\""
               puts $ch "    ::xmlutils::setXml \"GeneralApplicationData//c.Domain//i.Axisymmetric\" state \"write\" \"hidden\""
          } else {
               if {($wprops(SpaceDimenison,nDim) ne "2D")} {
                    puts $ch "    ::xmlutils::setXml \"GeneralApplicationData\" state \"write\" \"hidden\""
                    puts $ch "    ::xmlutils::setXml \"GeneralApplicationData//c.Domain\" state \"write\" \"hidden\""    
               }
          }
          puts $ch "    ::xmlutils::setXml \"GeneralApplicationData//c.Domain//i.SpatialDimension\" state \"write\" \"hidden\""
          
          # En caso de StructuralAnalysis
          if {$wprops(AppType,App) eq "StructuralAnalysis"} {
               # Hay que poner los Analysis types
               puts $ch "    ::xmlutils::setXml \"StructuralAnalysis//c.AnalysisData//i.StructuralType\" dv \"write\" $::kwiz::wprops(SpaceDimenison,ST)"
               puts $ch "    ::xmlutils::setXml \"StructuralAnalysis//c.AnalysisData//i.StructuralType\" state \"write\" \"hidden\""
               #puts $ch "    ::xmlutils::setXml \"StructuralAnalysis//c.AnalysisData//i.AnalysisType\" dv \"write\" $::kwiz::wprops(SpaceDimenison,AT)"
               #puts $ch "    ::xmlutils::setXml \"StructuralAnalysis//c.AnalysisData//i.AnalysisType\" state \"write\" \"hidden\""
          }
          # Que no se vean las applications
          puts $ch "    ::xmlutils::setXml \"GeneralApplicationData//c.ApplicationTypes\" state \"write\" \"hiddenAll\""
               
          puts $ch "\}"
          puts $ch "script"
      
          close $ch
          after 600 {
               set kratosdir "kratos.gid/Kratos/kratos.gid"
               if {[::kwiz::ExistGeometryMesh] eq 0} {
                    GiD_Process Mescape Data Defaults ProblemType $kratosdir escape
               } else {
                    GiD_Process Mescape Data Defaults ProblemType yes $kratosdir escape 
               }
          }
     } else {
          set auxfile [file nativename [file join [GidUtils::GetTmp] "KratosInitFile.tcl" ] ]
          set ch [open $auxfile w]
          puts $ch "set javivar 0"
          close $ch
          
          after 600 {
               
               set demdir "kratos.gid/DEM/kratos.gid"
               if {[::kwiz::ExistGeometryMesh] eq 0} {
                    GiD_Process Mescape Data Defaults ProblemType $demdir
               } else {
                    GiD_Process Mescape Data Defaults ProblemType yes $demdir escape 
               }
          }
     }
     if {[winfo exists $bwinpath]} {
          after 500 destroy $bwinpath
     }
     return 0
}

proc ::kwiz::ExistGeometryMesh {} {
     set existgeomesh 0
     
     set meshnodes [GiD_Info Mesh MaxNumNodes]
     set geopoints [GiD_Info Geometry NumPoints]
     if {($meshnodes) || ($geopoints)} {
      set existgeomesh 1    
     }
     return $existgeomesh
}

proc ::kwiz::NextEvent {stepnumber} {
     switch $stepnumber {
          0 {::kwiz::NextType}
          1 {::kwiz::NextnDim}
     }
}
proc ::kwiz::BackEvent {stepnumber} {

}

proc ::kwiz::checkNextButt {stepid varid} {
     if {$::kwiz::wprops($stepid,$varid) != 0} {
          after 100 {.gid.wtest.w buttonstate next normal}
     } else {
          after 100 {.gid.wtest.w buttonstate next disabled}
     }
}

proc ::kwiz::NextType { } {
     if {$::kwiz::wprops(AppType,App) != "DEM" && $::kwiz::wprops(AppType,App) != "DEMFluid"} {
          
     } else {
          variable bwinpath
          variable stepidlist
          .gid.wtest.w disable [lindex $stepidlist end]
          set ::kwiz::wprops(SpaceDimenison,nDim) 3D
          ::kwiz::CambiodeProblemType
     }
}

proc ::kwiz::NextnDim { } {
     ::kwiz::CambiodeProblemType
}

# Change button images step 1
proc ::kwiz::buttonPushedDim { win} {
    variable wprops
    variable bwinpath
    
     set okvalues [list "2D" "3D"]
     if { $wprops(SpaceDimenison,nDim) in $okvalues } {
         .gid.wtest.w buttonstate next normal
     } else {
         .gid.wtest.w buttonstate next disabled
     }
     if {$::kwiz::wprops(AppType,App) eq "StructuralAnalysis"} {
          ::kwiz::updateSTvalues $win
     }
}

proc ::kwiz::buttonPushedType {} {
     variable wprops

     .gid.wtest.w buttonstate next disabled
     
     if { $wprops(AppType,App) ne 0 } {
          # Si hay boton apretado
          .gid.wtest.w buttonstate next active
     } 
}

proc ::kwiz::updateSTvalues { win } {
     variable wprops
     
     set values [list "Select Dimension"]
     if {$wprops(SpaceDimenison,nDim) eq "2D"} {
          set values [list "Solid" "Generic"]          
     }
     if {$wprops(SpaceDimenison,nDim) eq "3D"} {
          set values [list "Beam" "Shell" "Membrane" "Solid" "Generic"]
     }
     
     $win.l2.c2 configure -values $values
     $win.l2.c2 current 0
}

proc ::kwiz::bodystepDim { win } {
     variable wprops
    
     catch {destroy $win.b1}
     catch {destroy $win.b2}
     
     # Set the widgets
     set img1 [::WinUtils::GetImage 2D.gif]
     set img2 [::WinUtils::GetImage 3D.gif]
     
     set lab2 [ttk::labelframe $win.l -text "Spatial dimention"]
     grid $lab2 -column 1 -row 0 -sticky we -pady 10
     
     set but1 [ttk::checkbutton $lab2.b1 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedDim $win" -variable ::kwiz::wprops(SpaceDimenison,nDim) -onvalue "2D"]
     set but2 [ttk::checkbutton $lab2.b2 -style TMenubutton.Toolbutton -image $img2 -command "::kwiz::buttonPushedDim $win" -variable ::kwiz::wprops(SpaceDimenison,nDim) -onvalue "3D"]
     

     # if STRUCTURAL
     if {$::kwiz::wprops(AppType,App) eq "StructuralAnalysis"} {
          
          set lab3 [ttk::labelframe $win.l2 -text "Analysis type"]
          grid $lab3 -column 1 -row 4 -sticky we
          #
          #set labAT [ttk::label $lab3.l1 -text "Analysis type:"]
          #set valuesAT [list Linear Non-Linear]
          #set comboAT [ttk::combobox $lab3.c1 -values $valuesAT -textvariable ::kwiz::wprops(SpaceDimenison,AT) -state readonly]
          #$comboAT current 0
          #grid $labAT -in $lab3 -column 1 -row 0 -padx [list 0 20] -sticky w
          #grid $comboAT -in $lab3 -column 2 -row 0
          #
          set labAT [ttk::label $lab3.l2 -text "Structural type:"]
          set valuesAT [list "Select dimension"]
          set comboAT [ttk::combobox $lab3.c2 -values $valuesAT -textvariable ::kwiz::wprops(SpaceDimenison,ST) -state readonly]
          $comboAT current 0
          grid $labAT -in $lab3 -column 1 -row 1 -padx [list 0 20] -sticky w
          grid $comboAT -in $lab3 -column 2 -row 1
          
          grid rowconfigure $lab3 0 -pad 20
     }
     
     # Set the grid
     grid $but1 -column 1 -row 2 -padx 25
     grid $but2 -column 3 -row 2 -padx 25
     
     # Configure the grid
     grid columnconfigure $win 0 -minsize 40
     grid columnconfigure $win 2 -minsize 50
     grid rowconfigure $win 1 -pad 40
     grid rowconfigure $win 2 -pad 40
     
     ::kwiz::checkNextButt "SpaceDimenison" "nDim"
}

proc ::kwiz::bodystepType { win } {
     variable wprops
      
     # Set the widgets
     set imgStruc [::WinUtils::GetImage struc.gif]
     set imgFlu [::WinUtils::GetImage fluid.gif]
     set imgConv [::WinUtils::GetImage convection.gif]
     set imgDemFlu [::WinUtils::GetImage demfluid.gif]
     set imgFreeSurf [::WinUtils::GetImage freeSurf.gif]
     
     set lab [ttk::label $win.l -text "Select application type:"]
     set lab1 [ttk::label $win.l1 -text "Structural analysis" -wraplength 150]
     set lab2 [ttk::label $win.l2 -text "Fluid" -wraplength 150]
     set lab3 [ttk::label $win.l3 -text "Convection diffusion" -wraplength 150]
     set lab4 [ttk::label $win.l4 -text "DEM + Fluid" -wraplength 150]
     set lab5 [ttk::label $win.l5 -text "Free surface flow" -wraplength 150]
     
     set but1 [ttk::checkbutton $win.b1 -style TMenubutton.Toolbutton -image $imgStruc -command "::kwiz::buttonPushedType" -variable ::kwiz::wprops(AppType,App) -onvalue "StructuralAnalysis"] 
     set but2 [ttk::checkbutton $win.b2 -style TMenubutton.Toolbutton -image $imgFlu -command "::kwiz::buttonPushedType" -variable ::kwiz::wprops(AppType,App) -onvalue "Fluid"]
     set but3 [ttk::checkbutton $win.b3 -style TMenubutton.Toolbutton -image $imgConv -command "::kwiz::buttonPushedType" -variable ::kwiz::wprops(AppType,App) -onvalue "ConvectionDiffusion"]
     set but4 [ttk::checkbutton $win.b4 -style TMenubutton.Toolbutton -image $imgDemFlu -command "::kwiz::buttonPushedType" -variable ::kwiz::wprops(AppType,App) -onvalue "DEMFluid"] 
     set but5 [ttk::checkbutton $win.b5 -style TMenubutton.Toolbutton -image $imgFreeSurf -command "::kwiz::buttonPushedType" -variable ::kwiz::wprops(AppType,App) -onvalue "FreeSurfaceFlow"] 
     
     # Set the grid
     grid $lab -column 1 -row 0 -sticky w
     
     grid $but1 -column 1 -row 2
     grid $but2 -column 2 -row 2
     grid $but3 -column 1 -row 5
     grid $but4 -column 2 -row 5
     grid $but5 -column 3 -row 2
     
     grid $lab1 -column 1 -row 3
     grid $lab2 -column 2 -row 3
     grid $lab3 -column 1 -row 6
     grid $lab4 -column 2 -row 6
     grid $lab5 -column 3 -row 3
     
     # Configure the grid
     grid rowconfigure $win 1 -minsize 15
     grid columnconfigure $win 0 -minsize 50
     grid columnconfigure $win 1 -pad 0
     grid columnconfigure $win 2 -pad 80
     grid columnconfigure $win 3 -pad 0

     ::kwiz::checkNextButt "AppType" "App"
}

proc ::kwiz::TopWindow { } {
    variable bwinpath
    wm attributes $bwinpath -topmost 1
}

# -np- ::kwiz::CreateInitWizard
proc ::kwiz::CreateInitWizard { } {
     variable bwinpath
     variable wprops
     variable stepidlist
         
     # Destroy the window 
     if {[winfo exists $bwinpath]} {
          destroy $bwinpath
     }
     
     # Create the window
     InitWindow $bwinpath [= "Kratos init window"] Pre::kwiz::CreateInitWizardWindowGeom
	
     # Centrar window
     wm withdraw $bwinpath
     
     set x [expr {([winfo screenwidth .gid.central.s]-[winfo width .gid.central.s])/2}]
     set y [expr {([winfo screenheight .gid.central.s]-[winfo height .gid.central.s])/2}]
     if { $x < 0 } { set x 0 }
     if { $y < 0 } { set y 0 }
     WmGidGeom $bwinpath +$x+$y
     update
     wm deiconify $bwinpath

     # Tamaos !
     wm minsize $bwinpath 530 450 
     wm maxsize $bwinpath 530 450 
     
     # First destroy all defined command (snit step data type)
     foreach cmdid [info commands ::kwiz::step*] {
          $cmdid destroy
     }
     
     
     ::kwiz::InitStepVariables
     # Create all the steps

     # Step 1: Space Dimension
     ::snitwiz::wizardstep ::kwiz::stepType -title [= "Step 1: Application Type"] -body {::kwiz::bodystepType $win}
    
     # Step 2: Application Type
     ::snitwiz::wizardstep ::kwiz::stepDim -title [= "Step 2: Analysis Type"] -layout basic -body {::kwiz::bodystepDim $win}

     # Render the wizard
     ::snitwiz::wizard $bwinpath.w -steps $stepidlist
          
     # Start the wizard
     $bwinpath.w start
     
}

# Init some namespace variables
::kwiz::Init